Attribute VB_Name = "BrowseFolderMod"
' Created on 3/27/24

' How to ADD:
' 1. add this module to your vba project
'		VBA -> File -> Import File -> choose the .bas file
'		Confirm module added in VBA -> View -> Project Explorer Window -> See name of file under Modules folder
		
' How to RUN:
' In your main() module of your macro, call these sub methods when you need it.
'   example of calling a subroutine
'       boolstatus = Module1.InsertPlane(swApp, distance_of_second_plane)
'   where Module1 is the name of the module (.bas file) and InsertPlane is the sub methode (sub or function) in the module

'   specific example
'       BrowseFolderMod.FolderBrowser "example"
'------------------------------------------------------------------------------
' Resources:
' 1. https://stackoverflow.com/questions/25352076/call-a-solidworks-macro-from-a-sub-and-pass-global-variables
'------------------------------------------------------------------------------


' Purpose:
'    To browser for a user selected folder.
' Return:
'    Full folder location string
Function FolderBrowser (Optional OpenAt As String) as String
  ' https://cadforum.net/viewtopic.php?t=1686
  ' https://answers.microsoft.com/en-us/msoffice/forum/all/how-do-you-save-a-file-to-the-desktop-form-vba/5d19aeb2-c287-4fea-b31c-ade003c589c8
  
  'If the "OpenAt" path is provided, open the browser at that directory
  'NOTE:  If invalid, it will open at the Desktop level

  Dim ShellApp As Object

  'Create a file browser window at the default folder
  Set ShellApp = CreateObject("Shell.Application").BrowseForFolder(0, "Please choose a folder", 0, OpenAt)

     'Set the folder to that selected.  (On error in case cancelled)
    On Error Resume Next
    FolderBrowser = ShellApp.self.Path & "\" 'set the function output based on user selection
    On Error GoTo 0

     'Destroy the Shell Application
    Set ShellApp = Nothing

     'Check for invalid or non-entries and send to the Invalid error handler if found
     'Valid selections can begin L: (where L is a letter) or
     '\\ (as in \\servername\sharename.  All others are invalid
    Select Case Mid(FolderBrowser, 2, 1)
    Case Is = ":"
        If Left(FolderBrowser, 1) = ":" Then GoTo Invalid
    Case Is = "\"
        If Not Left(FolderBrowser, 1) = "\" Then GoTo Invalid
    Case Else
        GoTo Invalid
    End Select

    Exit Function

Invalid:
     'If it was determined that the selection was invalid, set to default
    FolderBrowser = Createobject("WScript.Shell").SpecialFolders("Desktop") & "\"
end function